#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-parameter"
#pragma GCC diagnostic ignored "-Wwrite-strings"
#include <MeMCore.h>
boolean ausgabe_erlauben = false;
// extern über die vier RJ25-Ports
MeLEDMatrix ledMx(PORT_1);
MeLineFollower lineFinder(PORT_2);
MeUltrasonicSensor ultrasonic(PORT_3);
// onboard
MeLightSensor lightSensor(PORT_8);

MeBuzzer buzzer;
MeDCMotor motor1(M1); //Left Motor
MeDCMotor motor2(M2); //Right Motor
MeRGBLed led(0, 30);
const byte button = 7;

const byte max_strs = 10; // max. Anzahl der Teile eines Befehls
String strs[max_strs];    // Array für die Teile eines Befehls
int strs_length;          // aktuelle Anzahl der Teile eines Befehls
String zeile;             // enthält den seriell übermittelten Befehl

int linie, entfernung, helligkeit; // Messwerte der Sensoren

void setup() {
  Serial.begin(115200); Serial.println("\n  mBot-seriell-steuern.ino 2024-11-25\n");

  led.setpin(13);
  pinMode(button, INPUT); //Define button pin as input
  ledMx.setBrightness(6);
  ledMx.setColorIndex(1);
  ledMx.drawStr(0,7," hi ");
  // delay(1000);
  // ledMx.showNum(1.23);
  // delay(2000);
  led.setColor(0,0, 22);
  led.show();
  hilfe();
  // delay(2000);
} // Ende setup()

int dt1 = 250;
int dt2 = 1500;
unsigned long zeit1 = millis();
unsigned long zeit2 = millis();

void loop() {
  linie = lineFinder.readSensors();
  helligkeit = lightSensor.read();
  if (millis() > zeit1 + dt1) {
    zeit1 = millis();
    entfernung = ultrasonic.distanceCm();
    Serial.println("#");   
    digitalWrite(13,not digitalRead(13));
  }
  
  if (millis() > zeit2 + dt2) {
    zeit2 = millis();
    messwerte();
    //buzzer.tone(333, 10);
  }
  if (analogRead(A7)<100) {
        buzzer.tone(333, 220);
        asm volatile ("  jmp 0");  // Restarts program from beginning 
  }                               // but does not reset the peripherals and registers

  if (Serial.available()) {
    buzzer.tone(1333, 20);
    // String zeile = Serial.readString();
    zeile = Serial.readStringUntil('\n');
    zeile.trim();  // entfernt \r, falls vorhanden
    ausgabe("Eingabe: " + String(zeile.length()) + " Zeichen  |  " + zeile);
    if (zeile.length()==1) { //genau ein Zeichen
      zeichen_auswerten();
    } else {                 // mehr als ein Zeichen
      zeichenfolge_auswerten();
    }
  } // if (Serial.available...)
}